; icon from:
;   http://www.visualpharm.com
; via:
;   http://www.gettyicons.com/free-icon/112/finance-icon-set/free-calculator-icon-png/

; functions

; XXX: ScriptText should have #Persistent and a function def
;      Pass the script's text using ScriptText
;      Pass the name of the function in using FuncName
RunFuncInScriptWithInputText(ScriptText, FuncName, InputText)
{
  ; XXX: before didn't need to muck with path...
  AhkDll := AhkDllThread(A_ScriptDir . "\..\AHK\AutoHotkey.dll")
  ;OutputDebug, % "Script content: " . ScriptText
  AhkDll.ahkTextDll(ScriptText)
  OutputDebug, % "Value passing to script: " . InputText
  Result := AhkDll.ahkFunction(FuncName, InputText)
  OutputDebug, % "Script returned: " . Result
  AhkDll.Terminate()
  Return Result
}

Calculate(InputText)
{
  FuncName := "Calculate"
  ScriptText := "#Persistent`n`n"
              . "#NoTrayIcon`n`n"
              . FuncName . "()`n"
              . "{`n"
              . "  Result := " . InputText . "`n"
              . "  Return % Result . A_Space`n" ; XXX: convert to string
              . "}`n"
  Result := RunFuncInScriptWithInputText(ScriptText, FuncName, InputText)
  Result := RTrim(Result)
  ; XXX: consider whether to modify trailing zeros
  Return Result
}

; main

NParams = %0%

;OutputDebug, % "Number of parameters: " . NParams

If (NParams < 1)
{
  OutputDebug, % "Expected at least one argument but got: " . NParams
  SoundBeep
}
Else
{
  Input = %1%
  Result := Calculate(Input)
  OutputDebug, % Result
  ; XXX: how to output
  ;
  ; 1. via LargeType
  ;Run, % "AutoHotkey.exe LargeType.ahk " . """" . Result . """"
  ;
  ; 2. show in Qatapult
  SendToQatapult(Result)
}

ExitApp